
/* $Id: mousepad.c,v 1.1 2000/12/10 14:45:50 bergo Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "xpete.h"
#include "mousepad.h"

#include "gx/mleft.xpm"
#include "gx/mright.xpm"

extern int ldown, rdown;
extern GdkFont  *normal;

GtkWidget *mpad,*mda;
GdkPixmap *gk[4],*mcanvas;

int le[4]={0,0,85,96};
int ri[4]={255-85,0,255,96};

void create_pad() {
  GtkStyle *sty;
  GdkBitmap *mask;

  mpad=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_events(mpad,GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK);
  gtk_window_set_title(GTK_WINDOW(mpad),"xpete: Mouse Control");
  gtk_widget_set_usize(mpad,256,96);

  mda=gtk_drawing_area_new();
  gtk_widget_set_events(mda,GDK_EXPOSURE_MASK|GDK_POINTER_MOTION_MASK|GDK_BUTTON_PRESS_MASK);
  gtk_drawing_area_size(GTK_DRAWING_AREA(mda),256,96);
  gtk_container_add(GTK_CONTAINER(mpad),mda);

  gtk_widget_realize(mpad);
  gtk_widget_realize(mda);
  sty=gtk_widget_get_style(mpad);

  gk[0]=gdk_pixmap_create_from_xpm_d(mpad->window,&mask,NULL,mleft_xpm);
  gk[1]=gdk_pixmap_create_from_xpm_d(mpad->window,&mask,NULL,mright_xpm);

  mcanvas=gdk_pixmap_new(mpad->window,256,96,-1);
  draw_pad();

  gtk_signal_connect(GTK_OBJECT(mda),"expose_event",
                     GTK_SIGNAL_FUNC(mp_exposed),NULL);

  gtk_signal_connect(GTK_OBJECT(mpad),"delete_event",
                     GTK_SIGNAL_FUNC(mp_wdelete),NULL);

  gtk_signal_connect(GTK_OBJECT(mda),"motion_notify_event",
                     GTK_SIGNAL_FUNC(mp_move),NULL);
  gtk_signal_connect(GTK_OBJECT(mda),"button_press_event",
                     GTK_SIGNAL_FUNC(mp_click),NULL);

  gtk_signal_connect(GTK_OBJECT(mpad),"key_press_event",
		     GTK_SIGNAL_FUNC(keydown),NULL);
  gtk_signal_connect(GTK_OBJECT(mpad),"key_release_event",
		     GTK_SIGNAL_FUNC(keyup),NULL);

  gtk_widget_show(mda);
  gtk_widget_show(mpad);
}

void draw_pad() {
  GdkGC *mygc;

  mygc=gdk_gc_new(mda->window);
  gdk_rgb_gc_set_foreground(mygc,0);
  gdk_draw_rectangle(mcanvas,mygc,TRUE,0,0,256,96);

  gdk_rgb_gc_set_foreground(mygc,0x104080);
  gdk_draw_rectangle(mcanvas,mygc,TRUE,0,0,85,96);
  gdk_draw_rectangle(mcanvas,mygc,TRUE,255-85,0,85,96);

  gdk_rgb_gc_set_foreground(mygc,0xffffff);
  gdk_draw_string(mcanvas,normal,mygc,10,14,"Mouse buttons to shoot");
  gdk_draw_string(mcanvas,normal,mygc,10,26,"Mouse over regions to move");

  gdk_draw_pixmap(mcanvas,mygc,gk[0],0,0,26,32,32,32);
  gdk_draw_pixmap(mcanvas,mygc,gk[1],0,0,198,32,32,32);

  gtk_widget_queue_resize(mda);
  gdk_gc_destroy(mygc);
}

gboolean mp_wdelete(GtkWidget *w,gpointer data) {
  return TRUE;
}

gboolean mp_exposed(GtkWidget *w,GdkEventExpose *gee,gpointer data)
{
  gdk_draw_pixmap(w->window,
                  w->style->fg_gc[GTK_WIDGET_STATE (w)],
                  mcanvas,
                  gee->area.x, gee->area.y,
                  gee->area.x, gee->area.y,
                  gee->area.width, gee->area.height);
  return FALSE;
}

gboolean mp_move(GtkWidget *widget,GdkEventMotion *event,gpointer user_data) {
  int x,y;
  x=(int)(event->x);
  y=(int)(event->y);

  if ((x<0)||(y<0)||(x>256)||(y>96))
    return FALSE;

  ldown=inrect(x,y,le[0],le[1],le[2],le[3]);
  rdown=inrect(x,y,ri[0],ri[1],ri[2],ri[3]);
  return FALSE;
}

gboolean mp_click(GtkWidget *widget,GdkEventButton *event,gpointer user_data) {
  static GdkEventKey gek;
  gek.keyval=GDK_space;
  keydown(NULL,&gek,NULL);
  return FALSE;
}
